
/*
   Site Update - Update web pages
   by Denis G. Sureau - www.scriptol.com
   Licence: Mozilla 1.1

   Use freely this script
   but always provide the scriptol source and the licence when you distribute the program

   Principle:
   The program get a part of code enclosed between two tags,
   and copy it into each page holding the same two tags (replacing the
   enclosed part).
   The starting tag may be <!--XSTARTx--> or <!--XSTART0--> or <!--XSTART1-->,
   etc... until <!--XSTARTz-->
   Any letter may be used as indice, preferably use common ascii 0-9,
   A-Z, a-z...  The default is the X character, thus <!--XSTARTX-->.

   You can replace these tags by any ones defined in updater.ini.

   To use this tool, enclose a part of code in the model page between the starting and ending tags, 
   and put theses tag, enclosing nothing, in any page where you want to insert the same, enclosed code.
   
   You can use supdate also to insert text (the full content of a text file, written in this purpose)
   in a set of text files.
   
*/


``    This program is free software; you can redistribute it and/or modify
``    it under the terms of the OSS License.
``    This program is distributed in the hope that it will be useful,
``    but WITHOUT ANY WARRANTY; without even the implied warranty of
``    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  




include "path.sol"
include "dirlist.sol"

array extensions = {"htm", "html", "php", "php3", "php4", "php5", "xhtml", "dhtml", "asp"}
text tagstart ="<!--XSTARTX-->"
text tagend   ="<!--XENDX-->"
text listdir = "."		`` list of files, if we are using a list stored into a text file
array replacing		`` code to copy
array targetlist		`` list of file to update
text sourcefile 
boolean INSERTING = false

void usage()
  print
  print "Site Update 2.3 - Mozilla 1.1 Licence - www.scriptol.com"
  print "----------------- Insert or update a text into a list of files."
  print "Usage:"
  print "   supdate [options] sourcefile"
  print "or supdate [options] sourcefile targetdir (update all valid files in dir)"
  print "or supdate [options] sourcefile @targetlist"
  print "Options:"
  print "   #n      digit or letter to select a pair of markers (default is X)" 
  print "   -i      insert the whole source file at top of each page (no marker required)"
  print
  print "The code to insert or replace is recognized according to markers."
  print "A digit or letter may be given as parameter to select a marker."
  print "Example:  #1 for the marker <!--XSTART1--> while default is <!--XSTARTX-->"
  print "You have to put same markers into the source and each target document."
  print "Alternate kind of markers pair may be specified into supdate.ini."
  exit(0)
return


void readIni(text inipath)

	array ini
	inipath = Path.changeExt(inipath, "ini")
	if not file_exists(inipath) return
	ini.load(inipath)
	if(ini.size() = 0)
		print inipath, "file not loaded"
		return
	/if

	for text option in ini
		option = option.trim()        ` remove trailing spaces and eol
		if option.length() < 1 continue
		if option[0] = "#" continue
		int i = option.find("=")      ` parse a line
		if i = nil  continue          ` no valid couple key=value
		text k = option[--i].trim()   ` key
		text v = option[i+1..].trim() ` value
		if k
		= "start": tagstart = v
		= "end":   tagend = v
		= "extensions" : extensions = v.split(",")
		= "extension" : extensions = v.split(",")
		/if
	/for

return


int findInArray(array a, text t, int offset)
	if offset < 0  return -1	
	int num = offset
	for text x in a[offset .. ]
		if x.find(t) <> nil return num
		num + 1
	/for
return -1


`` Build the list of files to update

void buildList(text listname)
	if listname <> nil let targetlist.load(listname)
	if listdir <> nil:
		DirList d
		array temp = d.getList(listdir)
		targetlist = ()
		for text t in temp
			text node, ext
			node, ext = Path.splitExt(t)
			if ext in extensions
				if listdir <> "." let t = Path.merge(listdir, t)
				if Path.compare(sourcefile, t) continue      ` don't update the model!
				targetlist.push(t)
			/if
		/for
	/if

	if targetlist = nil let usage()
	
return	


`` Get the code to insert

void extracting()
	array source
	
	if not file_exists(sourcefile)
		print sourcefile, "not found"
		exit()
	/if
	
	source.load(sourcefile)
	if source.size() = 0
		print sourcefile, "source empty"
		exit(0)
	/if

	int numstt = findInArray(source, tagstart, 0)
	int numend = findInArray(source, tagend, numstt )
	if (numstt = -1) or (numend = -1)
		print "Nothing to update in", sourcefile
		print "these tags are required both in source and targets:"
		print tagstart, "(start of code to copy)"
		print tagend, "(end of code to copy)"
		exit(0)
	/if
	replacing = source[numstt .. numend]	`` Insert the code in each file in the list, inside markers 
	
return


`` Insert the code at top of each page

int inserting()

	array target
	int counter = 0

	for text t in targetlist
		t = t.trim()
		if t.length() = 0 continue
		if not file_exists(t)
			print t, "no found"
			continue
		/if
		target.load(t)
		if target.size() = 0
			print t, "target empty"
			continue
		/if

		file x
		x.open(t, "w")
		scan replacing let x.write(replacing[])
		scan target let x.write(target[])
		print t, "modified"
		counter + 1
		x.close()
	/for

return counter


`` Update  the code inside markers

int updating()

	array target
	int counter = 0

	int tarstt, tarend
	for text t in targetlist
		t = t.trim()
		if t.length() = 0 continue
		if not file_exists(t)
			print t, "no found"
			continue
		/if
		target.load(t)
		if target.size() = 0
			print t, "target empty"
			continue
		/if
		
		tarstt = findInArray(target,tagstart, 0)
		tarend = findInArray(target,tagend, tarstt )
		if (tarstt = -1) or (tarend = -1)
			print "nothing to replace in", t + ", skipped"
			continue
		/if
		target[tarstt .. tarend] = replacing
		
		file f = fopen(t, "wb")
		for text line in target
			f.write(line)
		/for
		f.close()
		
		print t, "updated"
		counter + 1
	/for

return counter

`` Main script

int main(int argc, array argv)

	if argc not in 2 ..  4 let usage()

	text listname = ""
	text tagindex = 'X'
	
	boolean modelgot = false
	boolean dirgot = false
	
	for text option in argv[ 1 .. ]
		text firstchar = option[0]
		if firstchar
		= "-":   
			if option 
			= "-i":	
				INSERTING = true
			else
				usage()
			/if	
		= "#":
			tagindex = option[1]		
		= "@":
			listname = option[1..]
		else
			if modelgot = true
				if dirgot = true let usage()
				listdir = option
				dirgot = true
			else
				sourcefile = option
				modelgot = true
			/if	
		/if	
	/for		
	
	readIni("supdate.ini")

	tagstart[10] = tagindex		`` remain # or get a number
	
	print "Extensions:", extensions.join(" ")

	if not file_exists(sourcefile)
		print sourcefile, "source file not found..."
		exit()
	/if

	buildList(listname)				`` Build the list of files to update
	
	int counter

	if INSERTING = true
		replacing.load(sourcefile)
		counter = inserting()
	else	
		extracting()						`` Get the code in the model, from markers	
		counter = updating()
	/if
	
	print counter, "files updated..."

return 0


main($argc, $argv)